#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_FieldParameter.h"
std::auto_ptr<Fish_FieldParameter> Fish_FieldParameter::msSingleton(nullptr);

int Fish_FieldParameter::GetCount()
{
	return (int)mMapData.size();
}

const Fish_FieldParameterData* Fish_FieldParameter::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_FieldParameterData>& Fish_FieldParameter::GetMapData()
{
	return mMapData;
}

void Fish_FieldParameter::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_FieldParameter.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_FieldParameterData data;
		data.mID = element->IntAttribute("ID");
		data.mRoomId = element->IntAttribute("RoomId");
		data.mBuffType = element->IntAttribute("BuffType");
		data.mNumber = element->IntAttribute("Number");
		data.mRateOfReturn = element->IntAttribute("RateOfReturn");
		data.mProbability = element->IntAttribute("Probability");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_FieldParameter Loaded. Load Data:%u", mMapData.size());
}

void Fish_FieldParameter::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_FieldParameter");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_FieldParameter");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_FieldParameterData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "RoomId", data.mRoomId);
		LuaCfgHelper::readInt(L, "BuffType", data.mBuffType);
		LuaCfgHelper::readInt(L, "Number", data.mNumber);
		LuaCfgHelper::readInt(L, "RateOfReturn", data.mRateOfReturn);
		LuaCfgHelper::readInt(L, "Probability", data.mProbability);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_FieldParameter Loaded. Load Data:%u", mMapData.size());
}

void Fish_FieldParameter::Reload()
{
	mMapData.clear();
	Load();
}

Fish_FieldParameter* Fish_FieldParameter::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_FieldParameter());
	}
	return msSingleton.get();
}

void Fish_FieldParameter::Release()
{
	msSingleton.reset(nullptr);
}
